#!/bin/bash

#   install_mail.sh - install a full mail server with a bunch of crap
#   This install is extremely inspired by http://workaround.org/articles/ispmail-etch/
#
#   DISS - Debian Install Server Scripts
#   A set of scripts to automate installation of Servers on Debian
#   (c) 2009 Emmanuel Revah - manu-at-manurevah.com
#
#   This file is part of DISS.
#
#   DISS is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   DISS is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with DISS.  If not, see <http://www.gnu.org/licenses/>.


clear
source /etc/diss/diss.conf
source ${SCRIPTS}/functions.sh

THISSCRIPT=install_mail.sh
THISSTATE=${MAILSTATE}
installStatus

DEPENDSTATE=${WEBSTATE}
DEPENDSON="install_lamp"
dependsOn

# need answers:
echo "

##########################################################

PLEASE READ THIS:

The mail server runs out of mysql, so we will
need to create a mysql user, one just for consulting the 
database \"mailuser\" and one for actually adding domains,
users, aliases and etc. \"mailadmin\".  they will mostly
be used by scripts and conf files.

The mail server installation is based on :
http://workaround.org/articles/ispmail-etch/

There are a few minor changes, like the part for adding
a web interface for managing email accounts from
http://www.grs-service.ch/pub/grs_mminstallation.html
and some additions such as Squirrelmail plugins and 
patches for better privacy and mail logs via Awstats.

##########################################################
"

getInpute "Enter the password for \"mailuser\":" pw
MAILUSERPASS="${ANSWER}"
getInpute "Enter the password for \"mailadmin\":" pw
MAILADMINPASS="${ANSWER}"

echo -n "
we should configure the first domain on the mail server.
we can use the default base domain: ${ADMINSITE} for this, 
if not please enter another domain name (default: ${ADMINSITE}): "
read MAILDOMAIN
: ${MAILDOMAIN:=$ADMINSITE}

echo -n "
IMPORTANT NOTE:
We shall create a mailbox for the main user
This user will also be used to manage all email accounts on this server
and will receive emails from the system.

By default we can use: ${ADMINUSER}  (will become ${ADMINUSER}@${MAILDOMAIN})
what will be the main email account to create ? (default ${ADMINUSER}): "
read MAILADMINUSER
: ${MAILADMINUSER:=$ADMINUSER}

getInpute "Set the password for ${MAILADMINUSER}@${MAILDOMAIN}:" pw
MAILADMINUSERPASS="${ANSWER}"

# confirmation
echo "confirm stuff

mail server
- mail server 'user' mysql pass: ${MAILUSERPASS}
- mail server 'admin' mysql pass: ${MAILADMINPASS}

domain: 
- mail domain: ${MAILDOMAIN}
- main email account: ${MAILADMINUSER}@${MAILDOMAIN}
- main email password: ${MAILADMINUSERPASS}

Please verify the above information before continuing"
confirmORdie

# install  mail server software
echo "
# added by diss (for clamav and stuff)
deb http://volatile.debian.org/debian-volatile etch/volatile main contrib non-free" >> /etc/apt/sources.list

apt-get update
apt-get upgrade -y
aptitude install -y  dovecot-pop3d dovecot-imapd amavisd-new spamassassin \
clamav-daemon cpio arj zoo nomarch lzop cabextract pax \
squirrelmail-locales squirrelmail-decode squirrelmail python \
squirrelmail-compatibility squirrelmail-quicksave squirrelmail-viewashtml \
patch
DEBIAN_PRIORITY=critical apt-get install -y avelsieve postfix-mysql postfix
squirrelmail-configure --install-plugin avelsieve
squirrelmail-configure --install-plugin quicksave
squirrelmail-configure --install-plugin view_as_html
pear install pear/DB

# dirty fix
apt-get remove --purge openbsd-inetd -y
rm /etc/inetd.conf
apt-get install openbsd-inetd -y

# SPAM STUFF NEEDS CHECKING
sed -i "s/ENABLED=0/ENABLED=1/" /etc/default/spamassassin

# change alias root: user1 to  ${MAILADMINUSER}@${MAILDOMAIN}
cp /etc/aliases /etc/aliases.diss-BKP
sed -i "s/root: `grep root: /etc/aliases|cut -d " " -f 2`/root: ${MAILADMINUSER}@${MAILDOMAIN}/" /etc/aliases
newaliases

# config mysql - create databases
mysqladmin -p${ROOTSQL} create mailserver
source ${SCRIPTS}/postfix-mysql.sh
mysql -p${ROOTSQL} < /root/postfix-mysql.sql
rm /root/postfix-mysql.sql

# config postfix
echo "user = mailuser
password = ${MAILUSERPASS}
hosts = 127.0.0.1
dbname = mailserver
query = SELECT 1 FROM virtual_domains WHERE name='%s'" > /etc/postfix/mysql-virtual-mailbox-domains.cf
postconf -e virtual_mailbox_domains=mysql:/etc/postfix/mysql-virtual-mailbox-domains.cf

SQLTEST=$(postmap -q ${MAILDOMAIN} mysql:/etc/postfix/mysql-virtual-mailbox-domains.cf)
if [ "${SQLTEST}" != "1" ]; then
	echo "there has been a problem, the domain ${MAILDOMAIN} has not been inserted in the database
please fix this. (test = 'postmap -q ${MAILDOMAIN} mysql:/etc/postfix/mysql-virtual-mailbox-domains.cf'
this command should return: \"1\"
you can press enter when ready to continue"
	read
fi

groupadd -g 5000 vmail && useradd -g vmail -u 5000 vmail -d /home/vmail -m
postconf -e virtual_uid_maps=static:5000
postconf -e virtual_gid_maps=static:5000

echo "user = mailuser
password = ${MAILUSERPASS}
hosts = 127.0.0.1
dbname = mailserver
query = SELECT 1 FROM view_users WHERE email='%s'" > /etc/postfix/mysql-virtual-mailbox-maps.cf
postconf -e virtual_mailbox_maps=mysql:/etc/postfix/mysql-virtual-mailbox-maps.cf

echo "user = mailuser
password = ${MAILUSERPASS}
hosts = 127.0.0.1
dbname = mailserver
query = SELECT destination FROM view_aliases WHERE email='%s'" > /etc/postfix/mysql-virtual-alias-maps.cf

echo "
user = mailuser
password = ${MAILUSERPASS}
hosts = 127.0.0.1
dbname = mailserver
query = SELECT email FROM view_users WHERE email='%s'" > /etc/postfix/mysql-email2email.cf
postconf -e virtual_alias_maps=mysql:/etc/postfix/mysql-virtual-alias-maps.cf,mysql:/etc/postfix/mysql-email2email.cf

chgrp postfix /etc/postfix/mysql-*.cf
chmod u=rw,g=r,o= /etc/postfix/mysql-*.cf

# dovecot
cp /etc/postfix/master.cf /etc/postfix/master.cf.diss-BKP
cp ${DEFCONFS}/mail/master.cf /etc/postfix/master.cf
postconf -e virtual_transport=dovecot
postconf -e dovecot_destination_recipient_limit=1

cp /etc/dovecot/dovecot.conf /etc/dovecot/dovecot.conf.diss-BKP
cp ${DEFCONFS}/mail/dovecot.conf /etc/dovecot/dovecot.conf
chmod 640 /etc/dovecot/dovecot.conf
chown root:vmail /etc/dovecot/dovecot.conf
sed -i "s/postmaster_address = postmaster@example.com/postmaster_address = ${MAILADMINUSER}@${MAILDOMAIN}/" /etc/dovecot/dovecot.conf

cp /etc/dovecot/dovecot-sql.conf /etc/dovecot/dovecot-sql.conf.diss-BKP
echo "
driver = mysql
connect = host=127.0.0.1 dbname=mailserver user=mailuser password=${MAILUSERPASS}
default_pass_scheme = PLAIN-MD5
password_query = SELECT email as user, password FROM view_users WHERE email='%u';" > /etc/dovecot/dovecot-sql.conf
mysql -p${ROOTSQL} -e "flush privileges"

/etc/init.d/dovecot restart

echo "we shall create a certificate for dovecot.

press enter when ready"
read

openssl req -new -x509 -days 730 -nodes -out /etc/ssl/certs/dovecot.pem -keyout /etc/ssl/private/dovecot.pem

postconf -e smtpd_sasl_type=dovecot
postconf -e smtpd_sasl_path=private/auth
postconf -e smtpd_sasl_auth_enable=yes
postconf -e smtpd_recipient_restrictions=permit_mynetworks,permit_sasl_authenticated,reject_unauth_destination

echo "and now one for postfix.

press enter when ready"
read

openssl req -new -x509 -days 730 -nodes -out /etc/ssl/certs/postfix.pem -keyout /etc/ssl/private/postfix.pem

chmod o= /etc/ssl/private/postfix.pem
postconf -e smtpd_tls_cert_file=/etc/ssl/certs/postfix.pem
postconf -e smtpd_tls_key_file=/etc/ssl/private/postfix.pem

cp ${DEFCONFS}/mail/20-debian_defaults /etc/amavis/conf.d/20-debian_defaults
cp ${DEFCONFS}/mail/15-content_filter_mode /etc/amavis/conf.d/15-content_filter_mode
cp /etc/spamassassin/local.cf /etc/spamassassin/local.cf.diss-BKP
cp ${DEFCONFS}/mail/local.cf /etc/spamassassin/local.cf

/etc/init.d/spamassassin restart
/etc/init.d/amavis restart

postconf -e content_filter=smtp-amavis:[127.0.0.1]:10024
postconf -e receive_override_options=no_address_mappings
postfix reload

adduser clamav amavis
sed -i "s/PhishingScanURLs true/#PhishingScanURLs true/" /etc/clamav/clamd.conf
sed -i "s/PhishingRestrictedScan true/#PhishingRestrictedScan true/" /etc/clamav/clamd.conf
sed -i "s/PhishingAlwaysBlockSSLMismatch false/#PhishingAlwaysBlockSSLMismatch false/" /etc/clamav/clamd.conf
sed -i "s/PhishingAlwaysBlockCloak false/#PhishingAlwaysBlockCloak false/" /etc/clamav/clamd.conf
sed -i "s/DetectPUA false/#DetectPUA false/" /etc/clamav/clamd.conf
/etc/init.d/clamav-daemon restart

echo "use strict;

@lookup_sql_dsn = (
    ['DBI:mysql:database=mailserver;host=127.0.0.1;port=3306',
     'mailuser',
     '${MAILUSERPASS}']);

\$sql_select_policy = 'SELECT *,email FROM view_users,policy'.
' WHERE (view_users.policy_id=policy.id)'.
' AND email IN (%k)';

\$sql_select_white_black_list = undef;

1;" > /etc/amavis/conf.d/50-user

# create global sieve file to filter out spam for all accounts
cp ${DEFCONFS}/mail/globalsieverc  /home/vmail/

# should maybe restart everyone just in case :]
postfix reload
/etc/init.d/amavis restart

# !!! add optionnal relay MX 
# source relay mx add script

#  VMAIL MANAGER
# - http://www.grs-service.ch/pub/grs_mminstallation.html
cd /home/www/outside-html/vmail_manager/
cp /usr/local/diss/softs/grs_mailmgr_v1_7.tgz .
tar zxvf grs_mailmgr_v1_7.tgz
sed -i "s/@@@dbname@@@/mailserver/" /home/www/outside-html/vmail_manager/conf/cnf_main_template.php
sed -i "s/@@@dbhost@@@/localhost/" /home/www/outside-html/vmail_manager/conf/cnf_main_template.php
sed -i "s/@@@dbuser@@@/mailadmin/" /home/www/outside-html/vmail_manager/conf/cnf_main_template.php
sed -i "s/@@@dbpassword@@@/${MAILADMINPASS}/" /home/www/outside-html/vmail_manager/conf/cnf_main_template.php
mv /home/www/outside-html/vmail_manager/conf/cnf_main_template.php /home/www/outside-html/vmail_manager/conf/cnf_main.php
rm -rf /home/www/outside-html/vmail_manager/install*
chmod 640 /home/www/outside-html/vmail_manager/conf/cnf_main.php
chown root:www-data /home/www/outside-html/vmail_manager/conf/cnf_main.php

# squirrelmail
mkdir /home/www/html/webmail/
ln -s /usr/share/squirrelmail/ /home/www/html/webmail/skwirrel
# configure squirrelmail
cp /usr/share/squirrelmail/config/config.php /usr/share/squirrelmail/config/config.php.diss-BKP
cp ${DEFCONFS}/mail/squirrel_config.php /usr/share/squirrelmail/config/config.php
cp /etc/squirrelmail/default_pref /etc/squirrelmail/default_pref.diss-BKP
cp ${DEFCONFS}/mail/squirrel_default_pref /etc/squirrelmail/default_pref
cp /etc/squirrelmail/quicksave-config.php /etc/squirrelmail/quicksave-config.php.diss-BKP
cp ${DEFCONFS}/mail/squirrel_quicksave-config.php /etc/squirrelmail/quicksave-config.php
cp /usr/local/diss/nimda/favicon.ico /usr/share/squirrelmail/
mkdir -p /home/www/outside-html/squirrelmail/data/
echo "Deny from All" > /home/www/outside-html/squirrelmail/data/.htaccess
chmod 770 /home/www/outside-html/squirrelmail/data/
chmod 640 /home/www/outside-html/squirrelmail/data/.htaccess
chown -R root:www-data /home/www/outside-html/squirrelmail/data/
# patch squirrelmail
# this is to hide webmail client's IP from outgoing headers
cp /usr/share/squirrelmail/class/deliver/Deliver.class.php /usr/share/squirrelmail/class/deliver/Deliver.class.php.diss-BKP
patch -p1 /usr/share/squirrelmail/class/deliver/Deliver.class.php < /usr/local/diss/squirrelmail/squirrelmail-1.4.6-privacy.diff 

# avelsieve bug "can't delete last filter rule"
cp /usr/share/squirrelmail/plugins/avelsieve/table.php /usr/share/squirrelmail/plugins/avelsieve/table.php.diss-BKP
patch /usr/share/squirrelmail/plugins/avelsieve/table.php /usr/local/diss/squirrelmail/table.patch

# take care of the plugins
cp /usr/local/diss/squirrelmail/*.tar.gz /usr/share/squirrelmail/plugins/
cd /usr/share/squirrelmail/plugins/
for SQPLUGIN in `ls /usr/share/squirrelmail/plugins/*.tar.gz`; do tar zxvf ${SQPLUGIN}; done
rm /usr/share/squirrelmail/plugins/*.tar.gz
cp username/config.php.sample username/config.php
cp avelsieve/config/config_sample.php avelsieve/config/config.php
cp ${DEFCONFS}/mail/squirrel-themes/* /usr/share/squirrelmail/themes/
cp ${DEFCONFS}/mail/vlogin_config.php vlogin/data/config.php
# configure change_sqlpass plugin
cp /usr/share/squirrelmail/plugins/change_sqlpass/config.php.sample /usr/share/squirrelmail/plugins/change_sqlpass/config.php
chown root:www-data /usr/share/squirrelmail/plugins/change_sqlpass/config.php
chmod 640 /usr/share/squirrelmail/plugins/change_sqlpass/config.php
sed -i "s#\$csp_dsn = 'mysql://user:password@localhost/email_users';#\$csp_dsn = 'mysql://mailadmin:${MAILADMINPASS}@localhost/mailserver';#" /usr/share/squirrelmail/plugins/change_sqlpass/config.php
sed -i "s#\$lookup_password_query = 'SELECT count(\*) FROM users WHERE username = \"%1\" AND crypt_password = %4';#\$lookup_password_query = 'SELECT count(\*) FROM view_users WHERE email = \"%1\" AND password = %4';#" /usr/share/squirrelmail/plugins/change_sqlpass/config.php
sed -i "s#'UPDATE users SET crypt_password = %4 WHERE username = \"%1\"',#'UPDATE view_users SET password = %4 WHERE email = \"%1\"',#" /usr/share/squirrelmail/plugins/change_sqlpass/config.php
sed -i "s/\$password_encryption = 'MYSQLPWD';/\$password_encryption = 'MD5';/" /usr/share/squirrelmail/plugins/change_sqlpass/config.php
sed -i "s#\$csp_salt_query = 'SELECT salt FROM users WHERE username = \"%1\"';#//\$csp_salt_query = 'SELECT salt FROM users WHERE username = \"%1\"';#" /usr/share/squirrelmail/plugins/change_sqlpass/config.php
sed -i "s#//\$csp_salt_query = '';#\$csp_salt_query = '';#" /usr/share/squirrelmail/plugins/change_sqlpass/config.php


echo "<VirtualHost *:80>
ServerName mail.${ADMINSITE}
ServerAlias mail.*
ServerAlias webmail.*
DocumentRoot /home/www/html/webmail/skwirrel
CustomLog /var/log/apache2/webmail.log combined
CustomLog /var/log/apache2/global.log combined
</VirtualHost>

<VirtualHost *:443>
ServerName mail.${ADMINSITE}
ServerAlias mail.*
ServerAlias webmail.*
SSLEngine on
SSLCertificateFile /etc/apache2/apache.pem
DocumentRoot /home/www/html/webmail/skwirrel
CustomLog /var/log/apache2/webmail.log combined
CustomLog /var/log/apache2/global.log combined
</VirtualHost>" > /etc/apache2/sites-available/webmail_squirrelmail
a2ensite webmail_squirrelmail
/etc/init.d/apache2 reload

# make web stats for squirrelmail
echo  "LogFile=\"/var/log/apache2/webmail.log\"
SiteDomain=\"mail.${ADMINSITE}\"
HostAliases=\"mail.*\"
AllowAccessFromWebToFollowingAuthenticatedUsers=\"${ADMINUSER}\"
DefaultFile=\"index.html\"
ShowFlagLinks=\"en de fr\"
Lang=\"en\"
Include \"include.conf\"" > /etc/awstats/awstats.mail.${ADMINSITE}.conf

# make web stats for email server usage
cp ${DEFCONFS}/awstats/awstats.mail.conf /etc/awstats/
sed -i "s/SiteDomain=/SiteDomain=\"mail.${ADMINSITE}\"/" /etc/awstats/awstats.mail.conf
sed -i "s/AllowAccessFromWebToFollowingAuthenticatedUsers=/AllowAccessFromWebToFollowingAuthenticatedUsers=\"${ADMINUSER}\"/" /etc/awstats/awstats.mail.conf

# add a link to the admin pages and add the awstats-cronbin line
sed -i "s/<!--REPLACED_BY_WEBMAIL_STATS-->/<li><a href=\"\/awstats\/awstats.pl?config=mail.${ADMINSITE}\">Webmail statistiques (for all domains with http or https)<\/a><\/li>/" ${ADMINNIMDAPATH}/index.php

sed -i "s/<!--REPLACED_WHEN_INSTALLING_MAIL_SERVER-->/<h2>Email Administration<\/h2>\n\
<ul>\n\
	<li><a href=\"\/vmail_manager\/login.php\">Vmail Manager<\/a><\/li>\n\
	<li><a href=\"\/awstats\/awstats.pl?config=mail\">Mail server statistiques<\/a><\/li>\n\
<\/ul>/" ${ADMINNIMDAPATH}/index.php

# pysieved
cp /usr/local/diss/softs/pysieved-HEAD.tar.gz /usr/local/
cd /usr/local/
tar xvf  pysieved-HEAD.tar.gz
cp ${DEFCONFS}/mail/pysieved.ini /usr/local/etc/
cp /etc/inetd.conf /etc/inetd.conf.diss-BKP
echo "# pysieved
sieve  stream  tcp  nowait  root  /usr/bin/python python /usr/local/pysieved/pysieved.py --inetd" >> /etc/inetd.conf
/etc/init.d/openbsd-inetd restart

# create spam and ham learn folders and cron a script or something
mkdir -p /home/vmail/${MAILDOMAIN}/${MAILADMINUSER}/maildir/.INBOX.Spam.Spam-Learn
mkdir -p /home/vmail/${MAILDOMAIN}/${MAILADMINUSER}/maildir/.INBOX.Spam.Ham-Learn
echo ".INBOX.Spam.Spam-Learn
.INBOX.Spam.Ham-Learn" >> /home/vmail/${MAILDOMAIN}/${MAILADMINUSER}/maildir/subscriptions
chown -R vmail:vmail /home/vmail/${MAILDOMAIN}/
chmod -R 700 /home/vmail/${MAILDOMAIN}/

echo "#!/bin/bash

SADIR=/var/lib/amavis/.spamassassin
DBPATH=/var/lib/amavis/.spamassassin/bayes
SPAMFOLDERS="\
	/home/vmail/${MAILDOMAIN}/${MAILADMINUSER}/maildir/.INBOX.Spam.Spam-Learn \
    "
HAMFOLDERS="\
	/home/vmail/${MAILDOMAIN}/${MAILADMINUSER}/maildir/.INBOX.Spam.Ham-Learn \
    "

for spamfolder in $SPAMFOLDERS ; do \
    echo Learning spam from $spamfolder ; \
    nice sa-learn --spam --showdots --dbpath $DBPATH $spamfolder
done

for hamfolder in $HAMFOLDERS ; do \
    echo Learning ham from $hamfolder ; \
    nice sa-learn --ham --showdots --dbpath $DBPATH $hamfolder
done

chown -R amavis:amavis $SADIR

sa-learn --dbpath /var/lib/amavis/.spamassassin/bayes --dump magic
exit" >> /usr/local/sbin/sa-learn-diss.sh
chmod +x /usr/local/sbin/sa-learn-diss.sh
echo "0 8 * * *	root	/usr/local/sbin/sa-learn-diss.sh" >> /etc/crontab 

# mark as done
sed -i "s/MAILSTATE=\"not installed\"/MAILSTATE=\"done\"/" ${DISSETC}/diss.conf

# firewall stuff - add new ports to diss.conf and restart firewall it is installed
NEWTCPPORTS="${ARNO_OPEN_TCP} 25 110 143 993 995"
sed -i "s/ARNO_OPEN_TCP=\"${ARNO_OPEN_TCP}\"/ARNO_OPEN_TCP=\"${NEWTCPPORTS}\"/" ${DISSETC}/diss.conf
if [ -a "/etc/arno-iptables-firewall/debconf.cfg" ]; then
	source /etc/arno-iptables-firewall/debconf.cfg
        sed -i "s/DC_OPEN_TCP=\"${DC_OPEN_TCP}\"/DC_OPEN_TCP=\"${NEWTCPPORTS}\"/" /etc/arno-iptables-firewall/debconf.cfg
        /etc/init.d/arno-iptables-firewall restart
fi

echo "
#########################

 stuff you need to know

#########################


domain:
- mail domain: ${MAILDOMAIN}
- main email account: ${MAILADMINUSER}@${MAILDOMAIN}
- main email password: ${MAILADMINUSERPASS}

- to add domains and or email accounts goto: https://${ADMINNIMDAURL}
- to use the webmail you can goto http://mail.${MAILDOMAIN}  
  (mail.* is configured in vhost, this means that for any domain hosted on
  this server the subdomain 'mail' will be configured to use squirrelmail)

Spam and Ham Learning :
to use this feature the user: ${MAILADMINUSER}@${MAILDOMAIN} can subscribe to 
.INBOX.Spam.Spam-Learn and .INBOX.Spam.Ham-Learn folders, move emails that 
need to be trained there, a Spam learning script will automatically scan and learn 
tokens from those IMAP folders once a day (8 am). the emails can be erased after
learning.  

[information you don't really need to remember but should keep somewhere.
it is stored in the postfix and dovecot conf files]

mail server
- mail server 'user' mysql pass: ${MAILUSERPASS}
- mail server 'admin' mysql pass: ${MAILADMINPASS}" >> /etc/diss/infos_mail
chmod 600 /etc/diss/infos_mail
echo "`cat /etc/diss/infos_mail`

press enter to return to DISS main menu"
read
exit
